package sumfuncts;

/**
 * @author Horst Lichter, Jochen Ludewig,
 * Software Engineering  Grundlagen, Menschen, Prozesse, Techniken, dpunkt.verlag,
 * (c) 2023
 */
public class RunTest {
  final static int MaxInt = Integer.MAX_VALUE, MinInt = Integer.MIN_VALUE;

  /**
   * Executes all defined test cases on all add functions
   * @param args starts the test driven
   */
  public static void main(String[] args) {
    System.out.println("Intuitiver Black-Box-Test");
    System.out.println("=========================");
    TestAddFunctions.testAll(5,       12, "T01");
    TestAddFunctions.testAll(-500,  -500, "T02");
    TestAddFunctions.testAll(999,      1, "T03");
    TestAddFunctions.testAll(-1000, 1000, "T04");
    
    System.out.println("Test von Grenzwerten und Sonderfaellen");
    System.out.println("======================================");
    TestAddFunctions.testAll(0,           0, "T05");
    TestAddFunctions.testAll(0,      MaxInt, "T06");
    TestAddFunctions.testAll(MaxInt,      0, "T07");
    TestAddFunctions.testAll(0,      MinInt, "T08");
    TestAddFunctions.testAll(MinInt,      0, "T09");
    TestAddFunctions.testAll(MinInt, MaxInt, "T10");
    TestAddFunctions.testAll(MaxInt, MinInt, "T11");

    System.out.println("Anweisungsueberdeckung");
    System.out.println("======================");
    TestAddFunctions.testAll(MaxInt / 2, 1000, "T12"); // S1 in add3
    TestAddFunctions.testAll(MaxInt - 8, -888, "T13"); // S2 in add8
    TestAddFunctions.testAll(8888, MaxInt + 8, "T14"); // S3 in add8

    System.out.println("Zweigueberdeckung");
    System.out.println("=================");
    TestAddFunctions.testAll(4444, 3333, "T15"); // ELSE-Zweig in add4
    TestAddFunctions.testAll(555,  -555, "T16"); // ELSE-Zweig in add5

    System.out.println("Termueberdeckung");
    System.out.println("================");
    TestAddFunctions.testAll(555,  5555, "T17"); // Kombination FALSE-TRUE
    TestAddFunctions.testAll(5555, -555, "T18"); // Kombination TRUE-FALSE
    TestAddFunctions.testAll(66,   6666, "T19"); // Kombination FALSE-TRUE

    System.out.println("Schleifentest add7");
    System.out.println("==================");
    TestAddFunctions.testAll(77, -7777, "T20");
    TestAddFunctions.testAll(78, -7777, "T21");

    System.out.println("Pfadueberdeckung add8");
    System.out.println("=====================");
    TestAddFunctions.testAll(MaxInt - 8, MinInt + 8, "T22");
    
    System.out.println ("Fehlerfall add9");
    System.out.println ("===============");
    TestAddFunctions.testAll (MaxInt/2 + 9, 9999, "T23");
    TestAddFunctions.testAll (MaxInt/2 + 9, MaxInt, "T24");
    
    System.out.println ("Max: " + MaxInt);
    System.out.println ("Min: " + MinInt);
    System.out.println ("Ueberlauf: " + (MaxInt + MaxInt + 2));
  }

}
