package sumfuncts;

/**
 * @author Horst Lichter, Jochen Ludewig,
 * Software Engineering  Grundlagen, Menschen, Prozesse, Techniken, dpunkt.verlag,
 * (c) 2023
 */
public class TestAddFunctions {

  /**
   * Executes the function add<no>, compares actual with expected
   * results and and prints the result as a row of a table.
   * X: test detected an error
   * E: an exception was thrown
   * @param a first summand
   * @param b second summand
   * @param no number of the test case
   */
  private static void testAdd(int a, int b, int no) {

    int res = 0;
    switch (no) {
      case 1: res = AddFunctions.add1(a, b); break;
      case 2: res = AddFunctions.add2(a, b); break;
      case 3: res = AddFunctions.add3(a, b); break;
      case 4: res = AddFunctions.add4(a, b); break;
      case 5: res = AddFunctions.add5(a, b); break;
      case 6: res = AddFunctions.add6(a, b); break;
      case 7: res = AddFunctions.add7(a, b); break;
      case 8: res = AddFunctions.add8(a, b); break;
      case 9: res = AddFunctions.add9(a, b); break;
    }
    try {
      if (res == Math.addExact(a, b)) System.out.print('-');
      else System.out.print('X');     
    } catch (ArithmeticException exc) {
        System.out.print('E');
    }
  }

  /**
   * Executes all add functions and prints the test case
   * @param a first summand
   * @param b second summand
   * @param tcID id of the test case
   */
  public static void testAll(int a, int b, String tcID) {
    System.out.print(tcID + " ");
    for (int i = 1; i <= 9; i++) {
      testAdd(a, b, i);
    }
    System.out.println("     " + a + "     " + b);
  }
}
